/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package expressiontree.operators.unary;

import apfloatextraclasses.ApfloatMatrixException;
import apfloatextraclasses.ApfloatMatrixMath;
import expressiontree.ExpressionTreeElement;
import expressiontree.operands.Matrix;
import expressiontree.operators.UnaryOperator;
import expressiontree.operands.NumberType;
import expressiontree.operators.IncompatibleNumberFormatException;
import org.apfloat.Apfloat;

/**
 * Az invertálás operátorok osztálya.
 * @author Esta
 */
public class Invert extends UnaryOperator {

    @Override
    public ExpressionTreeElement getValue() throws IncompatibleNumberFormatException {
        ExpressionTreeElement op1 = this.operands.get(0).getValue();
        if (op1 instanceof NumberType) {
            //Ha csak számot talál, akkor a szám reciprokát adja vissza.
            NumberType n = ((NumberType) this.operands.get(0));
            n.setValue(new Apfloat(1.0, this.precision).divide(n.getNumericValue()));
            return n;
        } else if (op1 instanceof Matrix) {
            try {
                Matrix m = (Matrix) op1;
                if (m.getCols() != m.getRows()) {
                    //Ha a mátrix nem négyzetes, esély sincs arra, hogy invertáljuk.
                    throw new IncompatibleNumberFormatException("ERROR_INVERT");
                }
                //Ha négyzetes mátrix, akkor invertálja Gauss-eliminációval.
                Matrix retValue = new Matrix(m.getCols(), m.getRows());
                retValue.setValues(ApfloatMatrixMath.gaussianElimination(m.getMatrixValues()));
                return retValue;
            } catch (ApfloatMatrixException ex) {
                throw new IncompatibleNumberFormatException(ex.getMessage());
            }
        } else { //Ez elvileg SOHA nem fordulhat elő.
            throw new IncompatibleNumberFormatException("ERROR_INVERT_UNKNOWN");
        }
    }

    @Override
    public String toText(boolean b) {
        if (b) {
            return "inv()";
        } else {
            return "inv ";
        }
    }

    @Override
    public String getLocalizedName() {
        return java.util.ResourceBundle.getBundle("languages/operators").getString("INVERT");
    }
}
